#ifndef MEMPHYSWCDigi_h
#define MEMPHYSWCDigi_h 1

#include "G4VDigi.hh"
#include "G4TDigiCollection.hh"
#include "G4Allocator.hh"
#include "G4ThreeVector.hh"
#include "G4Colour.hh"
#include "G4LogicalVolume.hh"
#include "G4Transform3D.hh"

//std
#include <vector>



class MEMPHYSWCDigi : public G4VDigi {

public:
  
  MEMPHYSWCDigi();
  virtual ~MEMPHYSWCDigi();
  int operator==(const MEMPHYSWCDigi&) const;
  
  inline void* operator new(size_t);
  inline void  operator delete(void*);
  
  void Draw(); //JEC FIXME what do we do with this?
  void Print();
  //JEC 1/12/05 implement same mechanism as Trajectory
  virtual const std::map<G4String,G4AttDef>* GetAttDefs() const;
  virtual std::vector<G4AttValue>* CreateAttValues() const;

private:

  //JEC make Ctor and assignation private
  MEMPHYSWCDigi(const MEMPHYSWCDigi&);
  const MEMPHYSWCDigi& operator=(const MEMPHYSWCDigi&);
  
  G4int   tubeID;
  G4float pe;   
  G4float time; 

  //JEC for vizu
  G4Colour         colour;
  G4Transform3D    transform;
  G4LogicalVolume* pLogV;
 
public:
  
  inline void SetTubeID(G4int tube) {tubeID = tube;}
  inline void SetPe(G4float Q)      {pe     = Q;}
  inline void SetTime(G4float T)    {time   = T;}

  //JEC 1/12/05 for vizu
  void SetColour(G4Colour aColour) { colour = aColour; }
  void UpdateColour() {/* not yet implemented */}
  inline void SetTransform(G4Transform3D aTrans) { transform = aTrans; }
  inline void SetLogicalVolume(G4LogicalVolume* logV) {pLogV = logV;}


  inline G4int   GetTubeID() {return tubeID;}
  inline G4float GetPe()     {return pe;}
  inline G4float GetTime()   {return time;}
  
};

//-----------------------------------------------------------------------

typedef G4TDigiCollection<MEMPHYSWCDigi> MEMPHYSWCDigitsCollection;
extern G4Allocator<MEMPHYSWCDigi> MEMPHYSWCDigiAllocator;

inline void* MEMPHYSWCDigi::operator new(size_t) {
  void* aDigi;
  aDigi = (void*) MEMPHYSWCDigiAllocator.MallocSingle();
  return aDigi;
}

inline void MEMPHYSWCDigi::operator delete(void* aDigi) {
  MEMPHYSWCDigiAllocator.FreeSingle((MEMPHYSWCDigi*) aDigi);
}

#endif









